const express = require('express');
const routes = require('./routes/index');
const cors = require('cors');

const app = express();

app.use(
    cors({
        credentials: true,
        origin: [process.env.FRONTEND_APP_URL]
    })
);

app.use('/', routes);

const server = app.listen(3000, () => {
    console.log(`Express is running on port ${server.address().port}`);
});

module.exports = app;
